#! /usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs-extra");
const _utils_1 = require('./src/utils');
const _commands_1 = require('./src/commands');
(() => __awaiter(this, void 0, void 0, function* () {
    let package_json = yield _utils_1.findNearestTarget(__dirname, 'package.json');
    let version = '0.0.0';
    if (package_json) {
        _utils_1.logger.debug('package.json\'s path:', package_json);
        let package_obj = yield fs.readJSON(package_json);
        version = package_obj.version || version;
    }
    else {
        _utils_1.logger.debug(`can't find package.json`);
    }
    _utils_1.logger.debug('version:', version);
    yield _commands_1.default(version, process.argv);
}))();
