"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _utils_1 = require('../../utils');
const blockCommentMark = [`/*`, `*/`];
const lineCommentMark = `//`;
exports.commentRegex = new RegExp(_utils_1.generateCommentRegexSource(blockCommentMark, lineCommentMark), 'g');
exports.blankLineRegex = /\s*\n+\s*/g;
exports.spacesRegex = /[ \t]+/g;
exports.leftSpacesRegex = /\s(?![\w_#])/g;
exports.rightSpacesRegex = /(?<![\w_])\s/g;
exports.includeRegex = /(#include\s*<\S+?>\s*)/g;
function removeComments(content) {
    let { invalidItems } = _utils_1.splitContentToCommentItems(content, blockCommentMark, lineCommentMark);
    return invalidItems.join('');
}
exports.removeComments = removeComments;
function removeSpaces(content) {
    let { validItems, invalidItems } = _utils_1.splitContentToQuotedItems(content);
    invalidItems = invalidItems
        .map(item => item.replace(exports.blankLineRegex, '\n'))
        .map(item => item.replace(exports.spacesRegex, ' '))
        .map(item => item.replace(exports.leftSpacesRegex, ''))
        .map(item => item.replace(exports.rightSpacesRegex, ''))
        .map(item => item.replace(exports.includeRegex, target => `${target}\n`));
    return _utils_1.mergeSourceItemsToContent({ validItems, invalidItems });
}
exports.removeSpaces = removeSpaces;
