"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs-extra");
const path = require("path");
function isFile(p) {
    return __awaiter(this, void 0, void 0, function* () {
        if (fs.existsSync(p)) {
            let stat = yield fs.stat(p);
            return stat.isFile();
        }
        return false;
    });
}
exports.isFile = isFile;
function isDirectory(p) {
    return __awaiter(this, void 0, void 0, function* () {
        if (fs.existsSync(p)) {
            let stat = yield fs.stat(p);
            return stat.isDirectory();
        }
        return false;
    });
}
exports.isDirectory = isDirectory;
function findNearestTarget(p, target) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!(yield isDirectory(p)))
            throw new Error(`\`${p}\` isn't a valid directory.`);
        let absolute_target = path.resolve(p, target);
        if (fs.existsSync(absolute_target))
            return absolute_target;
        let parentDir = path.dirname(p);
        if (parentDir != p)
            return yield findNearestTarget(parentDir, target);
        return null;
    });
}
exports.findNearestTarget = findNearestTarget;
