"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash = require("lodash");
const emm_logger_1 = require("emm-logger");
const localUtils = require('.');
var cmake_lists_1 = require("./cmake-lists");
exports.parseCMakeLists = cmake_lists_1.parseCMakeLists;
exports.generateExecutableTargetName = cmake_lists_1.generateExecutableTargetName;
var fs_helper_1 = require("./fs-helper");
exports.isFile = fs_helper_1.isFile;
exports.isDirectory = fs_helper_1.isDirectory;
exports.findNearestTarget = fs_helper_1.findNearestTarget;
var source_handler_1 = require("./source-handler");
exports.splitContentToCommentItems = source_handler_1.splitContentToCommentItems;
exports.splitContentToQuotedItems = source_handler_1.splitContentToQuotedItems;
exports.generateCommentRegexSource = source_handler_1.generateCommentRegexSource;
exports.generateQuotedRegexSource = source_handler_1.generateQuotedRegexSource;
exports.mergeSourceItemsToContent = source_handler_1.mergeSourceItemsToContent;
exports.logger = new emm_logger_1.EmmLogger('ws-ts', {
    level: emm_logger_1.INFO,
});
exports.default = new Proxy({}, {
    get: function (target, property, receiver) {
        if (property in localUtils)
            return localUtils[property];
        if (property in lodash)
            return lodash[property];
        throw new ReferenceError(`Property "${property}" does not exist.`);
    }
});
